/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	NSF loader(interface)
	mdx.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Project headers */
#include "nsf.h"
#include "uty.h"
#include "con_nsf.h"

static char prevnsf[MAX_PATH] = "";

char *LoadNSF(char *infile)
{
	int songno = 1;
	int songmax = 1;
	HANDLE hFile = CreateFile(
		infile,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	while (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD len = 0;
		char buf[8];
		if (0 == ReadFile(hFile, buf, sizeof(buf), &len, NULL)) break;
		if (GetDwordBE(buf) != 0x4e45534d/*NESM*/) break;
		if (lstrcmpi(prevnsf, infile) != 0)
		{
			lstrcpy(prevnsf, infile);
			songno = (((int)buf[7]) & 255);
			if (songno == 0) songno = 1;
			SetControler(songno);
		}
		songmax = (((int)buf[6]) & 255);
		if (songmax == 0) songmax = 1;
		break;
	}
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	SetControlerMax(songmax);
	SubclassWinamp();
	return infile;
}

void GetTitleNSF(char *fn, char *title)
{
	char head[8], buf[32];
	DWORD len;
	HANDLE hFile = CreateFile(
		fn,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	if (hFile != INVALID_HANDLE_VALUE && ReadFile(hFile, head, sizeof(head), &len, NULL) && len >= 4 && GetDwordBE(head) == 0x4e45534d/*NESM*/)
	{
		DWORD i = 0;
		char *p = title;
		SetFilePointer(hFile, 0xe, NULL, FILE_BEGIN);
		if (ReadFile(hFile, buf, sizeof(buf), &len, NULL) && buf[0] != '\x00')
		{
			for (i = 0; i < len; i++)
			{
				if (buf[i] == '\x00') break;
				*(p++) = buf[i];
			}
		}
		wsprintf(p, " (%d/%d)", GetControler(), head[6] & 255);
	}
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
}
